import os, sys
import numpy as np
import onnx
import ktc
import torch
import torch.onnx
import torch.nn as nn

onnx_output_path = '/docker_mount/rknn/output/trained_model/epoch19_4d.onnx'
optimized_onnx_output_path = '/docker_mount/kneron/output/epoch19_4d_optimized.onnx'
edit_optimized_onnx_output_path = '/docker_mount/kneron/output/epoch19_4d_optimized_edited.onnx'
inference_data_path = '/docker_mount/rknn/test_data/ori_train0.npy'

stage = 1

if stage <= 1 :
    print('----- stage 1')
    exported_m = onnx.load(onnx_output_path)

    # Optimize the exported onnx object
    result_m = ktc.onnx_optimizer.torch_exported_onnx_flow(exported_m)
    # onnx.save(result_m, onnx_output_path2)

    optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(result_m, eliminate_tail=True, opt_matmul=False)
    onnx.save(optimized_m, optimized_onnx_output_path)

if stage <= 2 :
    print('----- stage 2')
    model = onnx.load(optimized_onnx_output_path)
    node_names = 'Transpose_30'
    # node_names = 'LogSoftmax_33'
    edit_m = ktc.onnx_optimizer.cut_graph_from_nodes(model, node_names)

    optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(edit_m, eliminate_tail=True, opt_matmul=False)

    onnx.save(optimized_m, edit_optimized_onnx_output_path)


if stage <= 3 :
    print('----- stage 3')
    km = ktc.ModelConfig(32769, "0001", "720", onnx_path=edit_optimized_onnx_output_path)
    eval_result = km.evaluate()

# sys.exit(0)

if stage <= 4 :
    print('----- stage 4')
    inference_data = np.load(inference_data_path)
    inference_data = np.expand_dims(inference_data, axis=2)
    # inference_data = np.expand_dims(inference_data, axis=0)
    print(inference_data.shape)
    # inf_results = ktc.kneron_inference(inference_data, onnx_file=edit_optimized_onnx_output_path, input_names=['input'], platform=720)
    inf_results = ktc.kneron_inference(inference_data, onnx_file=edit_optimized_onnx_output_path, input_names=['input'])

# if stage <= 5 :

#     inference_data = np.load(inference_data_path)
#     inference_data = np.expand_dims(inference_data, axis=2)

#     # create the input mapping
#     input_data = [
#         input_data
#     ]
#     input_mapping = {"input": input_data}

#     # Quantization
#     bie_path = km.analysis(input_mapping, output_bie = None, threads = 1)

#     fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["input"])

#     compile_result = ktc.compile([km])

#     hw_results = ktc.kneron_inference(input_data, nef_file=compile_result, platform=530)

#     ktc.combine_nef(nef_path_list, output_path = "/data1/combined")

